# analyze smoldyn output

BEGIN{
  itot=0;
  Acurr = 0;
  Aprev = 0;
  Ncurr = 0;
  Nbinds = 0;
  i=0; 
  na=0; 
  nc=0; 
  Navg=0; 
  NavgSQ=0; 
  eta=0; 
  var=0;
  ieq = 0;
  iinterv = 1;
  Nperblock = 10000;
  iblock = 0;
  iperblock = 0;
  Navg_bl = 0;
  NavgSQ_bl = 0;
  Navg_BL = 0;
  NavgSQ_BL = 0;
  eta_bl = 0;
  eta_BL = 0;
  etaSQ_BL = 0;
} 

{
  itot+=1;
  Acurr = $2;
  Ncurr = $5;

  if ((itot%iinterv)==0) {
    if (itot > ieq) {
      i+=1;
      if (Acurr == 1) {
        na+=1;
      }
      else {
	nc+=1;
	if (Aprev == 1) {
	  Nbinds++;
	}
      }
      Aprev = Acurr;
      
      Navg+=$5; 
      NavgSQ+= $5 * $5;

      Navg_bl += $5;
      NavgSQ_bl += $5 * $5;
      iperblock += 1;
      if (iperblock >= Nperblock) {
	iperblock = 0;
	iblock+=1;

	Navg_bl /= Nperblock;
	NavgSQ_bl /= Nperblock;

	Navg_BL += Navg_bl;
	NavgSQ_BL += Navg_bl * Navg_bl;

	eta_bl = sqrt((NavgSQ_bl - (Navg_bl*Navg_bl))/(Navg_bl*Navg_bl));

	eta_BL += eta_bl;
	etaSQ_BL += eta_bl*eta_bl;

	Navg_bl = 0;
	NavgSQ_bl = 0;
      }
    }
  }
} 

END{
  Navg/=i; 
  NavgSQ/=i; 
  eta=sqrt((NavgSQ-(Navg*Navg))/(Navg*Navg)); 
  var=NavgSQ-(Navg*Navg); 
  print "Total entries:", itot, "Calculated entries:", i;
  print "N binds:", Nbinds;
  print "\nA: " na "\tC: " nc "\tpbound: " nc/i;
  print "<P>: " Navg "\t<P2>: " NavgSQ "\tstd: " sqrt(var) "\tnoise: " eta;

  Navg_BL /= iblock;
  NavgSQ_BL /= iblock;
  eta_BL /= iblock;
  etaSQ_BL /= iblock;
  print "\nAverages over " iblock " blocks\n";
  print "<P>: " Navg_BL " +- " sqrt(NavgSQ_BL - (Navg_BL*Navg_BL)) "  (" sqrt(NavgSQ_BL - (Navg_BL*Navg_BL))/Navg_BL*100 " %)";
  print "eta: " eta_BL " +- " sqrt(etaSQ_BL - (eta_BL*eta_BL)) "  (" sqrt(etaSQ_BL - (eta_BL*eta_BL))/eta_BL*100 " %)";
  print "";
}
