#include"types.h"
#include"geometry.h"

#include<stdlib.h>
#include<stdio.h>
#include<string.h>

void load_geometry(TLattice *lattice, TGeometry *geometry){
  FILE *f;
  int dim;
  Dimension size;
  int i;
  Dimension coord;
  Dimension n;
  int type;
  int numNeigh;

  geometry->cellTypeCount[0] = 0;
  geometry->cellTypeCount[1] = 0;
  geometry->cellTypeCount[2] = 0;

  if( geometry->filename == NULL){
    perror("cannot open NULL try file");
    exit(-1);
  }

  f = fopen(geometry->filename, "r");
  if(f == NULL){
    perror("cannot open geometry file");
    exit(-1);
  }

  fscanf(f, "%d\n", &dim);
  fscanf(f, "%d %d %d\n", &size.x, &size.y, &size.z);
  fscanf( f,"%d %d %d\n", &geometry->centre.x, &geometry->centre.y,\
	  &geometry->centre.z);
  
  while( EOF !=  fscanf(f, "%d %d %d %d %d ", &coord.x, &coord.y, &coord.z,&type, &numNeigh)){

    lattice->id[coord.x][coord.y][coord.z] = type;

    for(i=0; i < numNeigh; i++){
      fscanf(f,"%d %d %d ", &n.x, &n.y, &n.z);
      lattice->N[coord.x][coord.y][coord.z][i].x = n.x;
      lattice->N[coord.x][coord.y][coord.z][i].y = n.y;
      lattice->N[coord.x][coord.y][coord.z][i].z = n.z;
      
    }
    /*rest of neighbours are the current latice site*/
    for(i=numNeigh; i < 9; i++){
      lattice->N[coord.x][coord.y][coord.z][i].x = coord.x;
      lattice->N[coord.x][coord.y][coord.z][i].y = coord.y;
      lattice->N[coord.x][coord.y][coord.z][i].z = coord.z;
    }
    
    switch(type){
      case 0: /*in file: cytosol*/
      geometry->cellTypeCount[CYTOSOL]++; break;
      case 1:/*in file: memebrane*/
      geometry->cellTypeCount[MEMBRANE]++; break;
      case 2:/*this is cells's exterior */
      break;
    }
  }
	 
  fclose(f); 
}
  
