
#include<math.h>
#include<stdlib.h>
#include"types.h"

#ifndef __GILLESPIE__
#define __GILLESPIE__

typedef struct tdimensions{
  int x;
  int y;
  int z;
} TDimensions;

typedef struct tgillespie{
  int M; /* number of reactions */
  int N; /* number of Species */
  double *c; /* reaction rate for ith reaction */
  int (*cX)[10]; /* stoichometry matrix: c1X1 + c2X2 --> c3X3 + c4X4 + c5X5  ==> X1, c1, X2, c2, X3, c3, X4, c4 , X5, c5*/
  int boundedSpecies[MAXSPECIES]; /* indexes of membrane bounded species */
  double length;
  TOutput *output; /* if output==4, then print every reaction time A B C ...*/
  double simTime;
} TGillespie;

#define TRUE 1
#define FALSE 0
#define BOUNDED 1

void gillespie(TGillespie *data, tSite *siteFrom, double t_delta, double lambda);
/*void write_results(double time, int *nMolecules, int N);*/

#endif
