#include "types.h"
#include "gillespie.h"

#ifndef __PARTICLE_INIT__
#define __PARTICLE_INIT__

#define MAXCYTOSOL  4096000
#define MAXMEMBRANE 100000


/*delta width of the membrane. average diameter of a molecule, proteine*/
#define DX 100.0e-10  

typedef struct tlatticelin{
  Dimension cytosol[MAXCYTOSOL];
  Dimension membrane[MAXMEMBRANE];
  int iCytosolSize;
  int iMembraneSize;
} TLatticeLin;

void populate_lattice(TLattice *lattice, TGillespie *gillespie, TGeometry *geometry, TInitConditions *init, TDiffusion *diff);
void populate_species(TLattice *lattice,  TInitConditions *init, TLatticeLin *latticeLin, int *boundSpecies, int iSpecies, double siteLength);
void init_particles_membrane(TLattice *lattice, TInitConditions *init, TLatticeLin *latticeLin, int iSpecies, int particlesInitialization, double siteLength);
void init_particles_cytosol(TLattice *lattice, TInitConditions *init, TLatticeLin *latticeLin, int iSpecies, int particlesInitialization, double siteLength);
void throw_particles(TLattice *lattice, Dimension *sites, int sizeSites, int iSpecies, long int numbParticles);
void scan_sites(TLattice *lattice, TGeometry *geometry, TInitConditions *init, TLatticeLin *latticeLin);

#endif
