#include "types.h"
#include "gillespie.h"

#ifndef __RD_SIMULATION__
#define __RD_SIMULATION__


void reaction(TGillespie *reactionData,\
	      TLattice *lattice,\
	      double t_slot, int x, int y, int z, double lambda);



void set_cell_geometry(TLattice *lattice,\
			     TInitConditions *init,\
			     TGillespie *gillespie,\
			     TGeometry *geometry);

void initialize_lattice(TLattice *lattice,\
			TInitConditions *init,\
			TGillespie *gillespie,\
			TGeometry *geometry,\
			TDiffusion *diff);

void initialize_t_alarms(TGillespie *gillespie,\
			 TDiffusion *diffusion,\
			 double t_alarm[][2]);

void swap_lattices(TLattice *lattice);

double getNext_t_sim(TGillespie *gillespie,\
		     TTimes *times,\
		     double cur_time);

void rd_simulation(TLattice *lattice,\
		   TInitConditions *init,\
		   TGillespie *gillespie,\
		   TOutput *output,\
		   TDiffusion *diff,\
		   TTimes *times,\
		   TGeometry *geometry,\
		   int experiment);
#endif
